package cn.com.qmth.examcloud.task.service.producer;

import java.util.List;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import cn.com.qmth.examcloud.task.base.multithread.Producer;
import cn.com.qmth.examcloud.task.dao.entity.ReportsComputeEntity;
import cn.com.qmth.examcloud.task.service.ReportsComputeService;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;

public class ReportsComputeProducer extends Producer {
	private static final Logger LOG = LoggerFactory.getLogger(ReportsComputeProducer.class);

	private ReportsComputeService reportsComputeService = SpringContextHolder.getBean(ReportsComputeService.class);

	@Override
	protected void produce(Map<String, Object> param) throws Exception {
		LOG.info("***************************报表计算任务生产开始");
		Long sartId = 0l;
		Integer limit = 100;
		for (;;) {
			List<ReportsComputeEntity> list = reportsComputeService.findTodoData(sartId, limit);
			int count=0;
			if(list!=null) {
				count=list.size();
			}
			LOG.info("***************************startId:"+sartId+" count:"+count);
			if (list != null && list.size() > 0) {
				for(ReportsComputeEntity et:list) {
					sartId=et.getId();
					//生产数据
					offer(et);
				}
			} else {
				break;
			}
		}
		LOG.info("***************************报表计算任务生产结束");
	}
}
